//$Id: XPRIMAPI.H 1.6 1995/10/29 06:36:42 JOHN Exp $

#ifndef __XPRIMAPI__
#define __XPRIMAPI__

#ifndef __XAPI__
#include "XAPI.h"
#endif

#ifndef __XRTYPES__
#include "XRTypes.h"
#endif

struct RayHit3D;
struct Ray3D;
struct UVSpaceInfo;
struct FACET3D;
struct PATCH3D;

#if defined(qPointersD0) && defined(__MWERKS__) && defined(qPowerPC)
#pragma pointers_in_D0
#endif

typedef BOOLEAN  (RDXAPITYPE *XPrimRayHitProc)(ExternalInstance *data,const Ray3D *aR,FIXED tmin,FIXED tmax,RayHit3D *hit);
typedef void (RDXAPITYPE *XPrimGetAllInfoProc)(ExternalInstance *data,RayHit3D *hit);
typedef void (RDXAPITYPE *XPrimGetUVSpaceProc)(ExternalInstance *data,UVSpaceInfo* result);
typedef BOOLEAN (RDXAPITYPE *XPrimUV2XYZProc)(ExternalInstance *data,const VECTOR2 *uv,VECTOR3 *thePos3D);
typedef void (RDXAPITYPE *XPrimForEachFacetteProc)(ExternalInstance *data,void (*proc)(FACET3D *aF,void *priv),void *priv);
typedef void (RDXAPITYPE *XPrimForEachPatchProc)(ExternalInstance *data,void (*proc)(PATCH3D *aF,void *priv),void *priv);
typedef void (RDXAPITYPE *XPrimGetBBProc)(ExternalInstance *data,BOX3D *bbox);
typedef long (RDXAPITYPE *XPrimGetNbrUVSpaceProc)(ExternalInstance *data);

#if defined(qPointersD0) && defined(__MWERKS__) && defined(qPowerPC)
#pragma pointers_in_A0
#endif

#endif

